﻿namespace WinGridRowsRefresh
{
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        private Image isUpgradeImage;
        public Form1()
        {
            this.InitializeComponent();
            this.isUpgradeImage = Bitmap.FromFile(@"../../RedDot.png");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.orderBindingSource.DataSource = this.GetFirstData();
            this.OrdersGrid.DataSource = this.orderBindingSource;
        }

        private BindingList<Order> GetFirstData()
        {
            var orders = new BindingList<Order>();
            orders.Add(new Order(1, "First order", false));
            orders.Add(new Order(2, "Second order", false));
            orders.Add(new Order(3, "Third order", true));
            orders.Add(new Order(4, "Forth order", true));
            orders.Add(new Order(5, "Fifth order", false));
            orders.Add(new Order(6, "Sixth order", true));
            orders.Add(new Order(7, "Seventh order", false));

            return orders;
        }

        private BindingList<Order> GetSecondData()
        {
            var orders = new BindingList<Order>();
            orders.Add(new Order(1, "First order", false));
            orders.Add(new Order(2, "Second order", true));
            orders.Add(new Order(3, "Third order", true));
            orders.Add(new Order(4, "Forth order", false));
            orders.Add(new Order(5, "Fifth order", false));
            orders.Add(new Order(6, "Sixth order", true));
            orders.Add(new Order(7, "Seventh order", false));
            orders.Add(new Order(8, "Eighth order", false));
            orders.Add(new Order(9, "Ninth order", true));
            orders.Add(new Order(10, "Tenth order", true));

            return orders;
        }

        private void OnOrdersGridInitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            var isUpgradeAppearance = e.Layout.Appearances.Add("UpgradeAppearance");
            isUpgradeAppearance.ImageBackground = this.isUpgradeImage;
            isUpgradeAppearance.ImageBackgroundStyle = Infragistics.Win.ImageBackgroundStyle.Stretched;
        }

        private void OnOrdersGridInitializeRow(object sender, InitializeRowEventArgs e)
        {
            UltraGrid grid = sender as UltraGrid;

            if (grid != null)
            {
                /// Get the Order business object for that row
                var order = e.Row.ListObject as Order;

                if (order != null)
                {
                    UltraGridCell upgradeCell = e.Row.Cells["IsUpgradeCell"];
                    upgradeCell.Appearance = order.IsUpgradeCell ? grid.DisplayLayout.Appearances["UpgradeAppearance"] : null;
                }
            }
        }

        private void OnButtonGetNewDataClick(object sender, EventArgs e)
        {
            this.orderBindingSource.DataSource = this.GetSecondData();

            // The next row is not necessary when you set new data source
            // The grid should automatically refresh all rows
            this.OrdersGrid.Rows.Refresh(RefreshRow.FireInitializeRow, true);
        }
    }
}
